# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# Copyright IBM Corporation 2010. All rights reserved.
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

# import related classes
import sys

#-----------------------------------------------------------------
# Usage
#
#----------------------------------------------------------------
def usage():
	print "RelationshipDatabaseSchemaDrop.py is used to drop the database schema for a specific relationship."
	print "Usage:"
	print "<wsadmin_command> -lang jython -f RelationshipDatabaseSchemaDrop.py <relationship_full_name>"
	print "Where:"
	print "In windows, <wsadmin_command> is wsadmin.bat"
	print "In Linux/Unix, <wsadmin_command> is wsadmin.sh"
	print "<relationship_full_name> is the combination of the namespace and the name (in the form of <namespace>/<name>) that needs database schema dropping."

#------------------------------------------------------------------------------
# a utility method
#------------------------------------------------------------------------------
def wsadminToList( inStr ):
        outList = []
        if ( len( inStr ) > 0 and inStr[0] == '[' and inStr[-1] == ']' ):
                inStr = inStr[1:-1]
                tmpList = inStr.split( " " )
        else:
                tmpList = inStr.split( "\n" )   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();                           #removes any Windows "\r"
                if ( len( item ) > 0 ):
                        outList.append( item )
        return outList


#-----------------------------------------------------------------
# Main
#
#----------------------------------------------------------------

if len(sys.argv)==1:
	relFullName = sys.argv[0]
	print '**********************************'
	print 'Relationship service data clear up'
	print '**********************************'
	print 'Relationship full name: '+ relFullName
	queryName='WebSphere:type=RelationshipManagerMBean,*'
	print 'MBean query name: ' + queryName

	try:
		mbean = AdminControl.queryNames(queryName)
	except:
                print "Error found when querying MBean."
		raise
	else:
		if mbean=='':
			print "No MBean found."
			sys.exit(0)

	# split the mbean query result
	mbeanList = wsadminToList(mbean)
	print "Found MBean: ", mbeanList
	try:		
		found = "false"
		print 'Begin to drop the relationship database schema for the relationship ' + relFullName
		for currentMBean in mbeanList:
			print "---------------------------"
			print "For MBean: " + currentMBean
			rels = AdminControl.invoke(currentMBean, 'getAllRelationshipNames')
			relList = wsadminToList(rels)
			
			for currentRel in relList:
				if currentRel == relFullName:
					print "Found the matching relationship managed by this MBean."
					AdminControl.invoke(currentMBean,'dropRelationshipDatabaseSchema', relFullName)
					found = "true"
					break
			if found == "true":
				break
	except:
		print "---------------------------"
		print 'Error found when invoking the relationship manager MBean'
		raise
	else:
		print "---------------------------"
		if found == "false":
			print 'No matching relationship is found.'
		else:
			print 'Finished dropping the relationship database schema for the relatioship ' + relFullName
else:
	usage()
